package java.awt;

import java.beans.Transient;
import java.io.Serializable;
import java.awt.geom.Point2D;

public class Point extends Point2D implements Serializable
{
    public int x;
    public int y;
    private static final long serialVersionUID = -5276940640259749850L;
    
    public Point() {
        this(0, 0);
    }
    
    public Point(Point point) {
        this(point.x, point.y);
    }
    
    public Point(int x, int y) {
        this.x = x;
        this.y = y;
    }
    
    @Override
    public double getX() {
        return (double)this.x;
    }
    
    @Override
    public double getY() {
        return (double)this.y;
    }
    
    @Transient
    public Point getLocation() {
        return new Point(this.x, this.y);
    }
    
    public void setLocation(Point point) {
        this.setLocation(point.x, point.y);
    }
    
    public void setLocation(int n, int n2) {
        this.move(n, n2);
    }
    
    @Override
    public void setLocation(double n, double n2) {
        this.x = (int)Math.floor(n + 0.5);
        this.y = (int)Math.floor(n2 + 0.5);
    }
    
    public void move(int x, int y) {
        this.x = x;
        this.y = y;
    }
    
    public void translate(int n, int n2) {
        this.x += n;
        this.y += n2;
    }
    
    @Override
    public boolean equals(Object obj) {
        if ((obj instanceof Point)) {
            Point point = (Point)obj;
            return this.x == point.x && this.y == point.y;
        }
        return super.equals(obj);
    }
    
    @Override
    public String toString() {
        return this.getClass().getName() + "[x=" + this.x + ",y=" + this.y + "]";
    }
}
